// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef CLB_H
#define CLB_H

class registerBank;
class vprLUT;
class logicBlock;

class c_clb{
 public:
  string name;
  vector<logicBlock *> lutVector;
  vector<logicBlock *> registerVector;

  int row;
  int col;

  c_clb(string n){
    name = n;
    row = -1;
    col = -1;
  }

  int getNumLUTs(){return lutVector.size();};
  int getNumRegisters(){return registerVector.size();};

  void updateLocation(registerBank *block);
  void updateLocation(vprLUT *block);
  void clearLocation(registerBank *block);
  void clearLocation(vprLUT *block);
  void unPlaceLogicBlocksFromLUTsAndFF(registerBank *block);
  void unPlaceLogicBlocksFromLUTsAndFF(vprLUT *block);
  void unPlaceLogicBlocksFromLUTs(vprLUT *block);

  void placeLogicBlocksToLUTsAndFF(registerBank *block);
  void placeLogicBlocksToLUTsAndFF(vprLUT *block);
  void placeLogicBlocksToLUTs(vprLUT *block);

  void updateSinkDelaysAndSlacksForLUTsAndFF();
  void updateSinkDelaysAndSlacksForLUTs();

  void updateCostsAndDeltasForLUTsAndFF(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming);
  void updateCostsAndDeltasForLUTsAndFFCostDeltaDelay(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming, double *deltaTimingPrime);
  void updateCostsAndDeltasForLUTs(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming);
  void updateCostsAndDeltasForLUTsCostDeltaDelay(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming, double *deltaTimingPrime);
};

#endif
