// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

/* Error reporting functions */

/* The next avoids multiple inclusion of header files */
#ifndef MY_OWN_ERROR_H
#define MY_OWN_ERROR_H

/* Use ERROR for internal errors */
//void _Error(char *str, int line, char* file);
void _Error(string str, int line, string file);
#define ERROR(string) _Error((string), __LINE__, __FILE__)

/* Use EXT_ERROR for user (external) errors */
//void _Ext_Error(char *str);
void _Ext_Error(string str);
#define EXT_ERROR(string) _Ext_Error((string))

/* Use ASSERT for invariant tests, to be turned off in production code */
inline void _Assert(int test, int line, char *file)
{
  if (!test) 
    _Error("Assertion failed", line, file);
}

/* Set NDEBUG = 1 when NOT debugging - removes ASSERT statements */
#if defined(NDEBUG)
#define ASSERT(test)
#else
#define ASSERT(test) _Assert((test), __LINE__, __FILE__)
#endif

#if defined(GPLUSPLUS)
extern "C" double pow(double x, double y);
extern "C" long random();
extern "C" void srandom(int seed);
extern "C" char *strdup(char *string);
extern "C" void getrusage(int who, struct rusage *rusage);
#endif

#define RANDOM(x) ((int)(random()%(x)))

#endif
