// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

/****************************************************************
Class definition of a net as found in an mcnc netlist. Each net
has a clb source and possibly multiple clb sinks. Note that input
and output blocks are considered clbs here.
****************************************************************/ 
#ifndef MCNC_NET_H
#define MCNC_NET_H

#include "mcncBlock.h"

class mcncNet{
  //char name [MAX_STR_LEN];  //name of net
  string name;  //name of net
  list<mcncBlock*> sinkList;  //list of sink clbs
  mcncBlock* source;  //source clb
  int numSinks;  //num sink clbs
  int magicNum;
 public:
  mcncNet(){
    source=0;
    numSinks=0;
    magicNum=13111;
  }

  ~mcncNet(){
    if(magicNum!=13111)
      ERROR("trying to double delete a node...");
    else
      magicNum=0;
  }

  void set_name(char* n);  //set name of net
  void addto_sinkList(mcncBlock* p_block);  //add a block to sinkList
  void set_source(mcncBlock* p_block);  //set source of net

  string get_name();  //get name of net
  mcncBlock* get_source();  //get source of net
  int get_numSinks();  //get num of sinks

  void print_NetInfo();  //print info about this net
};


#endif
