// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef MCNC_PARSER_H
#define MCNC_PARSER_H

class mcncNet;
class routingNode;

/***
* FUNCTION DECLARATIONS
***/
void yyerror(char* str);
int yylex();
void processCircuitInfo(char*);
void process_mcncInputBlock(char*);
void process_mcncOutputBlock(char*);
void process_mcncClb(char*);
void process_mcncType();
void process_mcncPinlist(char*);
void process_mcncLUT();
void process_mcncRegister();
void process_mcncLatency();
mcncNet* find_mcncNet(char*);

routingNode* find_rnode(char*);
//void process_netlistFile(char*);
//void process_archFile(char*);
void process_placementFile(char*, int, int, int);
void process_blockName(char*);
void process_blockType(char*);
//void process_wireName(char*);
void process_sourceNode(int, int, int);
void process_sinkNode(int, int, int);
void process_ipinNode(int, int, int);
void process_opinNode(int, int, int);
void process_chanNode(int,int,int,int);
//void process_helperNode(int,int);
void process_Register(int,int, int);
void process_RegisterChain(int,int, int, int, int);
void process_Edges(int);
void process_switchTypes();
void connect_IONodes();

#endif
