#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#define NUM_ARCHS 27

void sortArchs(char **,int);
int getNumTracks(char *);
void findMinArch(char **,int);
int max (int,int);

char netlist [64];
char seed [32];
char exec [32];
char num_clb_rows [32];
char num_clb_cols [32];
char io_rat [32];
int num_searches = 0;
bool result_array [NUM_ARCHS];

int find_exp(int num_archs){
  int q = num_archs;int ctr=0;
  while(q!=0){
    q=q/2;++ctr;
  }
  return ctr;
}


int main(int argc,char **argv){
  FILE *fp;
  char* arch_names [NUM_ARCHS];
  int arch_ctr,i;
  char next_char;

  if(argc!=7){
    printf("\nINCORRECT NUMBER OF COMMAND LINE PARAMETERS");
    printf("\n./minfinder <exe> <netlist> <num_clb_rows> <num_clb_cols> <io_rat> <seed>\n\n");
    exit(1);
  }

  sprintf(exec,"%s",argv[1]);
  sprintf(netlist,"%s",argv[2]);
  sprintf(num_clb_rows,"%s",argv[3]);
  sprintf(num_clb_cols,"%s",argv[4]);
  sprintf(io_rat,"%s",argv[5]);
  sprintf(seed,"%s",argv[6]);

  num_searches = find_exp(NUM_ARCHS);

  for(i=0;i<NUM_ARCHS;i++)
    arch_names[i]=new char [100];

  arch_ctr=0;
  fp=fopen("arch_file","r");
  while(feof(fp)==0){
    if(arch_ctr>NUM_ARCHS){
      printf("\n\nARRAY INDEX IS %d & NUM_ARCHS IS %d",arch_ctr,NUM_ARCHS);
      printf("\n---- ARRAY OVERFLOW!! ----\n\n");
    }
    if(arch_ctr<NUM_ARCHS){
      fscanf(fp,"%s",arch_names[arch_ctr]);
      arch_ctr++;
    }
    else
      fscanf(fp,"%c",&next_char);
  }

  /* debug */
/*   printf("\n\n****** PRINT THE ARCHS ******\n"); */
/*   for(i=0;i<NUM_ARCHS;i++) */
/*     printf("%s\n",arch_names[i]); */
/*   printf("\n"); */
  /* debug */

  sortArchs(arch_names,NUM_ARCHS);
  findMinArch(arch_names,NUM_ARCHS);
  fclose(fp);

  return 0;
}


void findMinArch(char **arch_names,int num_archs){
  int max_index=(num_archs-1);
  int min_index=max_index/2;
  int curr_index;
  char *curr_arch;
  char system_call [512];
  char outfile [512];
  char statfile [64];
  char *status_string;
  FILE *fp,*status_fp;
  bool routed=false;int j;

  sprintf(statfile,"%s_minfinder.stat",seed);

  status_fp=fopen(statfile,"w");

  fprintf(status_fp,"\n****** START SEARCH ******\n");
  fflush(status_fp);

  for(int r=0;r<NUM_ARCHS;r++) result_array[r]=false;
  for(int g=0;g<num_searches;g++){
    curr_index=min_index;
    if(curr_index<0 || curr_index>=num_archs){
      fprintf(status_fp,"\n\nARRAY OVERFLOW IN BINARY SEARCH.");
      fflush(status_fp);
      fprintf(status_fp,"\nTOTAL NUM ARCHS IS %d WHILE INDEX IS %d\n\n",num_archs,
              curr_index);
      fflush(status_fp);
      break;
    }
    curr_arch=arch_names[curr_index];

    fprintf(status_fp,"\nLOOKING AT %s...",curr_arch);
    fflush(status_fp);

    /* create the output file */
    sprintf(outfile,"%s-%s-%s.output",netlist,curr_arch,seed);

    /* run the place and route code and store results in the output file */
    sprintf(system_call,"./%s %s %s %s %s %s %s > %s",exec,netlist,num_clb_rows,num_clb_cols,io_rat,curr_arch,seed,outfile);
    system(system_call);

    /* grep the output file to check whether UNROUTABLE? */
    sprintf(system_call,"grep 'CIGAR' %s > %s",outfile,seed);

    /* debug */
/*     printf("\nprint system_call --> %s\n",system_call); */
    /* debug */

    system(system_call);

/*     printf("\nGrepped %s\n",outfile); */

    /* open the file route_status and look for 'UNROUTABLE' */
    routed=true;status_string=new char [512]; 
    
    for(int idx=0;idx<512;idx++) status_string[idx]='\0';   

    fp=fopen(seed,"r");
    while(!feof(fp)){
      fscanf(fp,"%s",status_string);

/*       printf("\nstatus_string is %s\n",status_string);  */

      if(strstr(status_string,"CIGAR")!=0){
        routed=false;
      }
    }
    fclose(fp);
    sprintf(system_call,"rm %s",seed);
    delete [] status_string;
    system(system_call);

/*     printf("\n\trouted = "); */
/*     if(routed) printf("true");else printf("false");  */

    if(routed==true){
      result_array[curr_index]=true;
      min_index=min_index - max((max_index-min_index)/2,1);
      max_index=curr_index;
      fprintf(status_fp,"SUCCEEDED!!");
      fflush(status_fp);
    }
    else{
      min_index=min_index + max((max_index-min_index)/2,1);
      fprintf(status_fp,"FAILED!!");
      fflush(status_fp);
    }

  }

  for(j=0;j<num_archs && result_array[j]==false;j++){
    ;
  }

  if(j==(num_archs-1)){
    fprintf(status_fp,"\n\nNETLIST IS NOT ROUTABLE ON THIS SET OF ARCHITECTURES...\n\n");
    fflush(status_fp);
  }
  else{    
    fprintf(status_fp,"\n\nSMALLEST ARCHITECTURE IS %s\n\n",arch_names[j]);
    fflush(status_fp);
  }


  fclose(status_fp);

}

int max (int x,int y){
  if(x>y)
    return x;
  else
    return y;
}

void sortArchs(char **arch_names,int num_archs){
  int ti,tj;
  char *temp_arch;

  /* debug */
/*   printf("\n\n****** IN SORT ARCHS ******\n"); */
  /* debug */

  for(int i=0;i<num_archs;i++){
    for(int j=i+1;j<num_archs;j++){
      ti=getNumTracks(arch_names[i]);
      tj=getNumTracks(arch_names[j]);
      if(ti>tj){
        temp_arch=arch_names[i];
        arch_names[i]=arch_names[j];
        arch_names[j]=temp_arch;
      }
    }
  }

  /* debug */
/*   for(int k=0;k<num_archs;k++) */
/*     printf("%s\n",arch_names[k]); */
/*   printf("\n\n"); */
  /* debug */

}

int getNumTracks(char *arch_file){
  char s [3];
  char l [3];
  int num_short,num_long,num_tracks;

  /* debug */
/*   printf("\n\n****** IN GET NUM TRACKS ******\n"); */
  /* debug */

  s[2]='\0';
  l[2]='\0';
  s[0] = arch_file[13];
  s[1] = arch_file[14];
  l[0] = arch_file[20];
  l[1] = arch_file[21];

  num_short=atoi(s);
  num_long=atoi(l);
  num_tracks=num_short+num_long;

  /* debug */
/*   printf("NUM TRACKS IS = %d\n",num_tracks); */
  /* debug */

  return num_tracks;

}
