// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

class vprFPGA;
class Netlist;

void place(Netlist *netlist, bool pipeline_aware, bool timing_driven, FILE* fp, bool performInitialPlacement);
void ltAnneal(Netlist *netlist, bool pipeline_aware, bool timing_driven);
void independencePlacement(Netlist *netlist, bool timing_driven, FILE* fp);

void initPlacement(Netlist *netlist);

float calcStartTemperature(Netlist *netlist, bool timing_driven);
void generateMove(Netlist *netlist, void** block0,int* index0,void** block1,int* index1,int* block_type, float dLimit);
bool movable_block(logicBlock* lb);

void makeMove(void** block0,int* index0,void** block1,int* index1,int* block_type,int iter, bool timing_driven);
void undoMove(void** block0,int* index0,void** block1,int* index1,int* block_type,list<cachedObj*>* src_list0,
              list<cachedObj*>* src_list1,list<cachedObj*>* sink_list0,
              list<cachedObj*>* sink_list1,int iter, bool timing_driven);
void placeBlock(logicBlock* lb,void* b, enum e_timingMoveBlockType t,int index);
void unPlaceBlock(logicBlock* lb,void* b, enum e_timingMoveBlockType t,int index);

void placeLUT(logicBlock* lb, vprLUT* lut);
void unPlaceLUT(logicBlock* lb, vprLUT* lut);

void ripRoutes(logicBlock* lb0,logicBlock* lb1);

void annealDesign(Netlist *netlist, FILE* fp, bool timing_driven, float annealTemp);
void cacheRoutes(void** block0,int* index0,void** block1,int* index1,int* block_type,list<cachedObj*>* src_list0,
                 list<cachedObj*>* src_list1,list<cachedObj*>* sink_list0,
                 list<cachedObj*>* sink_list1);
void sortSinks(void** block0,int* index0,void** block1,int* index1,int* block_type);
void clearCachedRoutes(list<cachedObj*>* src_list0,list<cachedObj*>* src_list1,
		       list<cachedObj*>* sink_list0,list<cachedObj*>* sink_list1,int clear_tree);

int calcWireCost(Netlist *netlist);
void printNetsAndRecalcCosts(Netlist *netlist);

//void placeIO(Netlist *netlist);

void printPlacement(Netlist *netlist);
void printVPRPlacement(Netlist *netlist, long int random_seed, char* rr_echo, char* arguments, FILE* out_fp);

void swapBlocks(void** block0, int* index0, void** block1, int* index1, int* block_type);

void findCostAndCPofPlacement(Netlist *netlist);
