// Copyright (C) 2006 Ken Eguro, Scott Hauck, Akshay Sharma
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef ROUTE_H
#define ROUTE_H

//#include "Netlist.h"
class Netlist;
class vprFPGA;

void route(Netlist *netlist, bool pipeline_aware, bool timing_driven);
void routeNetsTimingDriven(Netlist *netlist, bool pipeline_aware, int iter, double criticalPathDelay);
void routeNetsCongestionDriven(Netlist *netlist, bool pipeline_aware, int iter);
void routeNetTimingDriven(int iter, Net* net, double criticalPathDelay);
void routeNetCongestionDriven(int iter, Net* net);
//void routeSink(int,Net*,routingNode*,int, bool);

void removeRouting(Netlist *netlist);

double cost_to_target(routingNode* rnode,routingNode* sink_rnode);

int calcWireCost(Netlist *netlist);

//void printNetsAndRecalcCosts(Netlist *netlist, bool pipeline_aware);

void routeNetPathFinderLockedRegistersTimingDriven(int iter, Net *net, double criticalPathDelay);
void routeNetPathFinderLockedRegistersCongestionDriven(int iter, Net *net);

void routePipelineNetPathFinderLockedRegistersTimingDriven(int iter, PipeliningNet *pNet, double criticalPathDelay);
void routePipelineNetPathFinderLockedRegistersCongestionDriven(int iter, PipeliningNet *pNet);

#endif
