#include <string>
#include <iostream>
#include <sstream>

using namespace std;

std::string itoa(const int& x){
  std::ostringstream o;
  if (!(o << x)) return "ERROR";
  return o.str();
}

int main(int argc, char** argv){
  string netlistName;
  int numRows;
  int numCols;
  int numTracks;
  string command;

  if(argc != 4){
    cout << "ERROR: Input error!" << endl;
    cout << "Usage: generateArchitectures #rows #columns #tracks" << endl;
  }

  //Argument $1 is the netlist, $2 is the number of rows, $3 is the number of columns, $4 is the number of tracks
  //Generate the rr_graph.echo file
  numRows = atoi(argv[1]);
  numCols = atoi(argv[2]);
  numTracks = atoi(argv[3]);

  //Generate the rr_graph.echo file
  command = "source ../vprGen/vprRRGraphGen/gen4x4LUTSHAREDIO_SRBLOCKS.sh  ~/pipeline/Armada_v0.98/vprGen/vprRRGraphGen " + 
    itoa(numRows) + " " + itoa(numCols) + " " + itoa(numTracks);

  system(command.c_str());
  
  //Rename the rr_graph.echo file something reasonable
  command = "mv rr_graph_" + itoa(numRows) + "x" + itoa(numCols) + "x" + itoa(numTracks)+ ".echo 4x4lut_SR_" + itoa(numRows) + "x" + itoa(numCols) + "x" + itoa(numTracks) + ".rrDelay";
  system(command.c_str());
  system("rm arch.echo");
  system("rm x.echo");
  system("rm y.echo");
  return 0;
}
