%{
#include "include.h"
#include "parse.tab.h"

extern long lineCount;
%}

%%

 /* Shared Tokens */

[ \t]* |
"#".* {
  /* Ignore whitespace, tabs and anything after a pound sign */
}

".global" {
  return TOKGLOBAL;
}

".input" {
  return TOKINPUT;
}

".output" {
  return TOKOUTPUT;
}

".clb" {
  return TOKCLB;
}

"pinlist:" {
  return TOKPINLIST;
}

"subblock:" {
  return TOKSUBBLOCK;
}

\n {
  lineCount++;
  return TOKENDL;
}


[_A-Za-z0-9\[\]\:]+ {
  strcpy(yylval.str, yytext);
  return TOKTEXT;
}

%%










